/*
 * NamedSubSequence.h
 *
 *  Created on: Apr 15, 2010
 *      Author: Oleksiy Kohany <kohany@gmail.com>
 */

#ifndef NAMEDSUBSEQUENCE_H_
#define NAMEDSUBSEQUENCE_H_

#include "SubSequence.h"
#include "NamedSequence.h"
/*
 *
 */
namespace bio {

   class NamedSubSequence : public NamedSequence, public SubSequence {
   protected:
      virtual void readFAHeaderLine(const string& s);
      virtual void readIGHeaderLine(const string& s);
   public:
      NamedSubSequence();
      NamedSubSequence(const NamedSubSequence& other);
      NamedSubSequence(const NamedSequence& other);
      NamedSubSequence(const SubSequence& other);
      NamedSubSequence(const string& name, const string& data);
      virtual ~NamedSubSequence();
      using Sequence::operator=;
      NamedSubSequence& operator=(const NamedSubSequence& other) {
         NamedSequence::operator=(other);
         SubSequence::operator=(other);
         return *this;
      }
      bool operator==(const NamedSubSequence& other) {
         return Sequence::operator==(other) && NamedSequence::operator==(other) && SubSequence::operator==(other);
      }
      virtual void clear() {
         NamedSequence::clear();
         SubSequence::clear();
      }
      virtual void printFAHeader(ostream& os, const char* comment = NULL) const;
      virtual void printIGHeader(ostream& os, const char* comment = NULL) const;
   };

}

#endif /* NAMEDSUBSEQUENCE_H_ */
