/*
 * ThreadPool.h
 *
 *  Created on: Dec 1, 2009
 *      Author: kohany
 */

#ifndef THREADPOOL_H_
#define THREADPOOL_H_

#include <pthread.h>

using namespace std;

class ThreadPool {
      int threadCount;
      bool poolIsBusy;
      pthread_t *workerThreads;
      void* currentMethod;
      void* currentMethodData;
   public:
      ThreadPool();
      ThreadPool(int threadCount);
      virtual ~ThreadPool();
      void initWorkers(void *(*func)(void*), void* args, size_t stack_size = 0x40000);
      void joinWorkers();
      int getThreadCount();
      void setThreadCount(int count);
      static size_t getCoreCount();
};

#endif /* THREADPOOL_H_ */
